/*****************************************************************************/
/*                                                                           */
/*   Program : Common Constants header file of Plug-In-able Switching System */
/*   Author  : Seung-su Yang                                                 */
/*   Date    : 9/24/1999                                                     */
/*                                                                           */
/*****************************************************************************/

/*** Define Constants ***/

#define TRUE	1
#define FALSE	0
#define ERROR	-1
#define OK	1
#define NOK	0
#define MAX_LOGSTRING_SIZE	256
#define MAX_FILENAME_SIZE	256
#define MAX_SESSION_NO	256
#define MAX_PROCESS_NO	256
#define MAX_PK_SIZE	512
#define MAX_BUFFER_SIZE	512

/*** Define Ports ID ***/
#define CTRL_PORT	5000
#define DATA_PORT	5500

/*** Define Constant Size ***/
#define BACK_LOG	1024

/*** Define Session Control Commands ***/

#define SESSION_CREATE		1000
#define SESSION_CREATE_ACK	1001
#define SESSION_RELEASE		1002
#define SESSION_RELEASE_ACK	1003
#define SESSION_CTRL		1004
#define SESSION_CTRL_ACK		1005

/*** Define Prc Control Commands ***/

#define PROCESS_CREATE		2000
#define PROCESS_CREATE_ACK	2001
#define PROCESS_RELEASE		2002
#define PROCESS_RELEASE_ACK	2003
#define PROCESS_CTRL		2004
#define PROCESS_CTRL_ACK		2005

/*** Define Prcor Identification ***/

#define CTRL_PACKET	1000
#define PROCESS_PACKET	2000
#define DATA_PACKET	3000
#define MANAGE_PACKET	4000

/*** Define Specific Handler ***/

#define RT_HNDR	10

/*** Define Switchlet Commands ***/

#define SWLET_CTRL	0	/* Switchlet Control */
#define SWLET_END	1	/* Switchlet Control End */
#define SWLET_DATA	2	/* Swithclet Data */
#define SWLET_KILL	3	/* Switchlet Kill */

/*** Define Route Switchlet Commands ***/

#define RTC_TBL_INIT	10	/* Route Control Tbl Initialize */
#define RTC_TBL_LOAD	11	/* Route Control Tbl Load */
#define RTC_TBL_FLUSH	12	/* Route Control Tbl Flush */
#define RTC_ETR_ADD	13	/* Route Control Entry Add */
#define RTC_ETR_REMOVE	14	/* Route Control Entry Remove */
