
/*****************************************************************************/
/*                                                                           */
/*   Program : Common Functions of Plug-In-able Switching System             */
/*   Author  : Seung-su Yang                                                 */
/*   Date    : 9/24/1999                                                     */
/*                                                                           */
/*****************************************************************************/

#include "CommHeader.h"
#include "CommFunc.h"

#define MasterCfgFile	"master.cfg"

int
HtoNstSsCtrlData(pstDstSsCtrlData, pstSrcSsCtrlData)
struct StSsCtrlData *pstDstSsCtrlData, *pstSrcSsCtrlData;
{
	pstDstSsCtrlData->ulCcId = htonl(pstSrcSsCtrlData->ulCcId);
	pstDstSsCtrlData->ulSrcId = htonl(pstSrcSsCtrlData->ulSrcId);
	pstDstSsCtrlData->ulSsId = htonl(pstSrcSsCtrlData->ulSsId);
	return OK;
}

int
NtoHstSsCtrlData(pstDstSsCtrlData, pstSrcSsCtrlData)
struct StSsCtrlData *pstDstSsCtrlData, *pstSrcSsCtrlData;
{
	pstDstSsCtrlData->ulCcId = ntohl(pstSrcSsCtrlData->ulCcId);
	pstDstSsCtrlData->ulSrcId = ntohl(pstSrcSsCtrlData->ulSrcId);
	pstDstSsCtrlData->ulSsId = ntohl(pstSrcSsCtrlData->ulSsId);
	return OK;
}

int
HtoNstPkHdr(pstDstPkHdr, pstSrcPkHdr)
struct StPkHdr *pstDstPkHdr, *pstSrcPkHdr;
{
	pstDstPkHdr->ulSrcId = htonl(pstSrcPkHdr->ulSrcId);
	pstDstPkHdr->ulSsId = htonl(pstSrcPkHdr->ulSsId);
	pstDstPkHdr->ulSeqNo = htonl(pstSrcPkHdr->ulSeqNo);
	pstDstPkHdr->ulPrcId = htonl(pstSrcPkHdr->ulPrcId);
	pstDstPkHdr->ulRtgInf = htonl(pstSrcPkHdr->ulRtgInf);
	pstDstPkHdr->ulDataId = htonl(pstSrcPkHdr->ulDataId);
	pstDstPkHdr->ulPkSize = htonl(pstSrcPkHdr->ulPkSize);
	return OK;
}

int
NtoHstPkHdr(pstDstPkHdr, pstSrcPkHdr)
struct StPkHdr *pstDstPkHdr, *pstSrcPkHdr;
{
	pstDstPkHdr->ulSrcId = ntohl(pstSrcPkHdr->ulSrcId);
	pstDstPkHdr->ulSsId = ntohl(pstSrcPkHdr->ulSsId);
	pstDstPkHdr->ulSeqNo = ntohl(pstSrcPkHdr->ulSeqNo);
	pstDstPkHdr->ulPrcId = ntohl(pstSrcPkHdr->ulPrcId);
	pstDstPkHdr->ulRtgInf = ntohl(pstSrcPkHdr->ulRtgInf);
	pstDstPkHdr->ulDataId = ntohl(pstSrcPkHdr->ulDataId);
	pstDstPkHdr->ulPkSize = ntohl(pstSrcPkHdr->ulPkSize);
	return OK;
}

int
UltoSzulRtgInf(szBuf, ulRtgInf)
char *szBuf;
unsigned long ulRtgInf;
{
	struct StulRtgInf{
		unsigned char uc1;
		unsigned char uc2;
		unsigned char uc3;
		unsigned char uc4;
	};
	union UnulRtgInf {
		struct StulRtgInf stulRtgInf;
		unsigned long ulRtgInf;
	} uulRtgInf;

	uulRtgInf.ulRtgInf = ulRtgInf;
	sprintf(szBuf, "%d.%d.%d.%d", uulRtgInf.stulRtgInf.uc1, uulRtgInf.stulRtgInf.uc2, uulRtgInf.stulRtgInf.uc3, uulRtgInf.stulRtgInf.uc4);
	return OK;
}

int
SztoUlulRtgInf(pulRtgInf,szBuf)
unsigned long *pulRtgInf;
char *szBuf;
{
	struct StulRtgInf{
		unsigned char uc1;
		unsigned char uc2;
		unsigned char uc3;
		unsigned char uc4;
	};
	union UnulRtgInf {
		struct StulRtgInf stulRtgInf;
		unsigned long ulRtgInf;
	} uulRtgInf;
	char szTmpBuf[20];
	int i,j;

	uulRtgInf.ulRtgInf = 0;
	i = 0;
	j = 0;
	while ((j < 19) && isdigit(szBuf[i])) {
		szTmpBuf[j++] = szBuf[i++];
	}
	szTmpBuf[j] = '\0';
	uulRtgInf.stulRtgInf.uc1 = (unsigned char) atoi(szTmpBuf);
	if (szBuf[i] == '.')
		i++;
	if (szBuf[i] == '\0') {
		*pulRtgInf = uulRtgInf.ulRtgInf;
		return OK;
	}

	j = 0;
	while ((j < 19) && isdigit(szBuf[i])) {
		szTmpBuf[j++] = szBuf[i++];
	}
	szTmpBuf[j] = '\0';
	uulRtgInf.stulRtgInf.uc2 = (unsigned char) atoi(szTmpBuf);
	if (szBuf[i] == '.')
		i++;
	if (szBuf[i] == '\0') {
		*pulRtgInf = uulRtgInf.ulRtgInf;
		return OK;
	}

	j = 0;
	while ((j < 19) && isdigit(szBuf[i])) {
		szTmpBuf[j++] = szBuf[i++];
	}
	szTmpBuf[j] = '\0';
	uulRtgInf.stulRtgInf.uc3 = (unsigned char) atoi(szTmpBuf);
	if (szBuf[i] == '.')
		i++;
	if (szBuf[i] == '\0') {
		*pulRtgInf = uulRtgInf.ulRtgInf;
		return OK;
	}

	j = 0;
	while ((j < 19) && isdigit(szBuf[i])) {
		szTmpBuf[j++] = szBuf[i++];
	}
	szTmpBuf[j] = '\0';
	uulRtgInf.stulRtgInf.uc4 = (unsigned char) atoi(szTmpBuf);
	*pulRtgInf = uulRtgInf.ulRtgInf;
	return OK;
}

int
NtoHstSwletCmd(pstDstSwletCmd, pstSrcSwletCmd)
struct StSwletCmd *pstDstSwletCmd, *pstSrcSwletCmd;
{
	pstDstSwletCmd->ulCId = ntohl(pstSrcSwletCmd->ulCId);
	pstDstSwletCmd->ulCSize = ntohl(pstSrcSwletCmd->ulCSize);
	pstDstSwletCmd->iShmId = ntohl(pstSrcSwletCmd->iShmId);
	return OK;
}

int
HtoNstSwletCmd(pstDstSwletCmd, pstSrcSwletCmd)
struct StSwletCmd *pstDstSwletCmd, *pstSrcSwletCmd;
{
	pstDstSwletCmd->ulCId = htonl(pstSrcSwletCmd->ulCId);
	pstDstSwletCmd->ulCSize = htonl(pstSrcSwletCmd->ulCSize);
	pstDstSwletCmd->iShmId = htonl(pstSrcSwletCmd->iShmId);
	return OK;
}

char *GetIpAddr(szAddr, szIpAddr)
char *szAddr, *szIpAddr;
{
	int iCtrlPort, iDataPort;
	if (GetAddrInf(szAddr, szIpAddr, &iCtrlPort, &iDataPort) == ERROR) {
		return NULL;
	}
	return szIpAddr;
}

int
GetCtrlPort(szAddr)
char *szAddr;
{
	int iCtrlPort, iDataPort;
	char szIpAddr[50];

	if (GetAddrInf(szAddr, szIpAddr, &iCtrlPort, &iDataPort) == ERROR) {
		return 0;
	}
	return iCtrlPort;
}

int
GetDataPort(szAddr)
char *szAddr;
{
	int iCtrlPort, iDataPort;
	char szIpAddr[50];

	if (GetAddrInf(szAddr, szIpAddr, &iCtrlPort, &iDataPort) == ERROR) {
		return 0;
	}
	return iDataPort;
}

int
GetAddrInf(szAddr, szIpAddr, piCtrlPort, piDataPort)
char *szAddr, *szIpAddr;
int *piCtrlPort, *piDataPort;
{
	FILE *fp;
	char szStr[256];
	char szName[50], szIpName[50];
	char *pszAddr, *pszName;
	int iAddr, iName;

	if (toupper(szAddr[0]) != 'K') {
		printf("Given address is not regulary accepted %s.\n", szAddr);
		return ERROR;
	}

	pszAddr = &szAddr[1];
	iAddr = atoi(pszAddr);

	if ((fp = fopen(MasterCfgFile, "r")) == NULL) {
		printf("Error in open Master Configuration File.\n");
		return ERROR;
	}

	while (!feof(fp)) {
		fgets(szStr, 256, fp);
		while ((szStr[0] == '#') && !feof(fp)) {
			fgets(szStr, 256, fp);
		}
		if (szStr[0] != '#') {
			sscanf(szStr, "%s%s%d%d", szName, szIpName, piCtrlPort, piDataPort);
			pszName = &szName[1];
			iName = atoi(pszName);
			if (iAddr == iName) {
				strcpy(szIpAddr, szIpName);
				fclose(fp);
				return OK;
			}
		}
	}
	fclose(fp);
	return ERROR;
}
