
/*****************************************************************************/
/*                                                                           */
/*   Program : Common Structure header file of Plug-In-able Switching System */
/*   Author  : Seung-su Yang                                                 */
/*   Date    : 9/24/1999                                                     */
/*                                                                           */
/*****************************************************************************/


/*** Structure for Communication ***/

struct StPkHdr {	/* Structure of Packet Header */
	unsigned long ulSrcId;
	unsigned long ulSsId;
	unsigned long ulSeqNo;
	unsigned long ulPrcId;
	unsigned long ulRtgInf;
	unsigned long ulDataId;
	unsigned long ulPkSize;
};

struct StPk {		/* Structure of Packet */
	struct StPkHdr stPkHdr;
	unsigned char sData[MAX_PK_SIZE-sizeof(struct StPkHdr)];	/* Total Packet size = 512 bytes */
};


/*** Structure for represent Session ***/

struct StPkInf {	/* Structure of Packet Information */
	unsigned long ulHndrId;
	int iShmId;
	struct StPkHdr stPkHdr;
	unsigned char *psPkData;
};

struct StPkCmpo {	/* Struct of Packet Component */
	int iShmId;
	struct StPkInf *pstPkInf;
	struct StPkCmpo *pstPkCmpoNxt;
};

struct StSsInf {	/* Structure of Session Information */
	int bSsAlive;
	int iShmId;	/* For Session Specific Data */
};

struct StSsCmpo {	/* Structure of Session Component */
	unsigned long ulSrcId;
	unsigned long ulSsId;
	struct StSsInf stSsInf;
	struct StPkCmpo *pstPkCmpo;
};


/*** Structure for Session Control ***/

struct StSsCtrlData {	/* Struct of Session Control Data Structure */
	unsigned long ulCcId;	/* ControlCodeId */
	unsigned long ulSrcId;
	unsigned long ulSsId;	/* SessionId */
};

/*** Structure for Prc ***/

struct StPrcInf {	/* Struct of Prc Information */
	unsigned long ulPrcId;
};

struct StPrcCmpo {	/* Struct of Prc Component */
	unsigned long ulPrcId;
	struct StPrcInf stPrcInf;
	char *pszExecCodeLoc;
};

struct StPrcTbl {	/* Struct of Prc Table */
	unsigned long ulDataType;
	struct StPrcCmpo *pstPrcCmpo;
};

/*** Structure for Control Switchlet ***/

struct StSwletCmd {	/* Struct of Switchlet Cmd */
	unsigned long ulCId;	/* Command Id */
	unsigned long ulCSize;	/* Command Size */
	int iShmId;		/* Session Info Shared Memory Id */
};
