/*****************************************************************************/
/*                                                                           */
/*   Program : Traffic Generator of Plug-In-able Switching System            */
/*   Author  : Seung-su Yang                                                 */
/*   Date    : 9/24/1999                                                     */
/*                                                                           */
/*****************************************************************************/

#include "CommHeader.h"
#include "TrafGen.h"

#define TrafGenErrLog	"TrafGenErr.log"

int giTrafGenErrLogFd;
extern char gszErrLog[MAX_LOGSTRING_SIZE];


int
TrafGenInit(szTxtTrafSrc, piDataFd)
char *szTxtTrafSrc;
int *piDataFd;
{
	if ((giTrafGenErrLogFd = open(TrafGenErrLog, O_WRONLY | O_APPEND | O_CREAT, S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH)) == -1) {
		PutTrafGenSts("Error Log files can not access.");
		return ERROR;
	}

	if ((*piDataFd = open(szTxtTrafSrc, O_RDONLY)) < 0) {
		sprintf(gszErrLog, "Error in Openning Data File.\n");
		write(giTrafGenErrLogFd, gszErrLog, strlen(gszErrLog));
		PutTrafGenSts(gszErrLog);
		close(giTrafGenErrLogFd);
		return ERROR;
	}

	return OK;
}

/* Send Data to Session */
int
SendTrafGenDataToSession(szTxtSwNameIpAddr, ulSrcAddr, ulSsId, ulDstAddr, ulTrafTypeId, iDataFd, iCtrlPort, iDataPort)
char *szTxtSwNameIpAddr;
unsigned long ulSrcAddr, ulSsId, ulDstAddr, ulTrafTypeId;
int iDataFd;
{
	int iUdpSkFd;
	int i,j;
	struct StPk stPk;
	struct sockaddr_in stSsDataSkAddr;

	i = 0;
	
	bzero(&stPk, sizeof(stPk));
	stPk.stPkHdr.ulSrcId = ulSrcAddr;
	stPk.stPkHdr.ulSsId = ulSsId;
	stPk.stPkHdr.ulPrcId = DATA_PACKET;
	
	stPk.stPkHdr.ulRtgInf = ulDstAddr;
	stPk.stPkHdr.ulDataId = ulTrafTypeId;

	bzero(&stSsDataSkAddr, sizeof(stSsDataSkAddr));
	stSsDataSkAddr.sin_family = AF_INET;
	stSsDataSkAddr.sin_port = htons(iDataPort);
	inet_pton(AF_INET, szTxtSwNameIpAddr, &stSsDataSkAddr.sin_addr);

	iUdpSkFd = socket(AF_INET, SOCK_DGRAM, 0);

	HtoNstPkHdr(&stPk.stPkHdr, &stPk.stPkHdr);

	while ((j = read(iDataFd, &stPk.sData, sizeof(stPk.sData))) > 0) {
		stPk.stPkHdr.ulSeqNo = htonl(i++);
		stPk.stPkHdr.ulPkSize = htonl(j);
		if (sendto(iUdpSkFd, &stPk, sizeof(stPk), 0, &stSsDataSkAddr, sizeof(stSsDataSkAddr)) < 0) {
			sprintf(gszErrLog, "Error in Sending Data.\n");
			write(giTrafGenErrLogFd, gszErrLog, strlen(gszErrLog));
			PutTrafGenSts(gszErrLog);
		}
		sleep(1);
	}
	
	sprintf(gszErrLog, "Total Sending Packet %d.\n", i);
	write(giTrafGenErrLogFd, gszErrLog, strlen(gszErrLog));
	PutTrafGenSts(gszErrLog);
	close(iUdpSkFd);
	return OK;
}
