
/*****************************************************************************/
/*                                                                           */
/*   Program : Traffic Receiver of Plug-In-able Switching System             */
/*   Author  : Seung-su Yang                                                 */
/*   Date    : 9/24/1999                                                     */
/*                                                                           */
/*****************************************************************************/

#include "CommHeader.h"

extern int giErrLogFd;
extern char gszErrLog[MAX_LOGSTRING_SIZE];
extern int giDataPort;

extern void PutTrafSts(char *);

/* Send Data to Session */
int
ReceiveDataFromSession(iDataFd)
int iDataFd;
{
	int iUdpSkFd;
	int iUdpSkLength;
	int iReadSize;
	int i;

	struct sockaddr_in stUdpSkAddr;
	struct sockaddr_in stTmpUdpSkAddr;
	struct StPk stPk;
	

	iUdpSkFd = socket(AF_INET, SOCK_DGRAM, 0);
	
	bzero(&stUdpSkAddr, sizeof(stUdpSkAddr));
	stUdpSkAddr.sin_family = AF_INET;
	stUdpSkAddr.sin_addr.s_addr = htonl(INADDR_ANY);
	stUdpSkAddr.sin_port = htons(giDataPort);
	
	bind(iUdpSkFd, (struct sockaddr *)&stUdpSkAddr, sizeof(stUdpSkAddr));

	i = 0;
	while ((iReadSize = recvfrom(iUdpSkFd, &stPk, sizeof(stPk), 0, &stTmpUdpSkAddr, &iUdpSkLength)) > 0) {
		NtoHstPkHdr(&stPk.stPkHdr, &stPk.stPkHdr);
		write(iDataFd, stPk.sData, stPk.stPkHdr.ulPkSize);
		i++;
		sprintf(gszErrLog, "receive SrcId %ld, SessionId %ld, SequenceNo %ld. Size %ld\n", stPk.stPkHdr.ulSrcId, stPk.stPkHdr.ulSsId, stPk.stPkHdr.ulSeqNo, stPk.stPkHdr.ulPkSize);
		write(giErrLogFd, gszErrLog, strlen(gszErrLog));
		PutTrafSts(gszErrLog);
	}
	sprintf(gszErrLog, "Total Receive Packet %d.\n", i);
	write(giErrLogFd, gszErrLog, strlen(gszErrLog));
	close(iUdpSkFd);
	return OK;
}
